#define NAME	 "Change"
#define VERSION  "2"
#define REVISION "19"
//#define DEBUG
//#define DEBUG_LOOP
#define ENDCODE

/* Programmheader

	Name:		Change
	Author:		SDI
	Distribution:	PD
	Description:	sucht und tauscht Zeichen in Dateien aus
	Compileropts:	-
	Linkeropts:	-l amiga

 1.20	: Fehler mit NOCHANGE und Pattern behoben
 1.21	: PATH ergnzt jetzt das \0 am Ende
 1.22	: Parameterberprfung ins Hauptprogramm
 1.23	: Bug bei zwei gleichen Anfangsbuchstaben des Suchstrings entfernt
 1.24	: InfoText Bearbeitung verbessert, Fehlermeldungen eingebaut
 1.25	: BUG durch InOutSDI.h entfernt
 1.26	: defsSDI.h, InOutSDI.h, ConvertSDI.h neu
 1.27	: bei ? am Anfang des Suchstrings beschleunigt
 1.28	: Quelltext kommentiert
 1.29	: Programm ein wenig beschleunigt / verbessert
 1.30	: BUG entfernt (If-Abfrage falsch)
 1.31	: BUG bei PATTERN-Angabe entfernt
 1.32	: verbesserte Includes, einige Programmverbesserungen
 1.35	: auf vollkommen neue Includes umgestellt
 2.0	: einige Verbesserungen, GUI komplett
 2.1	: Text optimiert, Trennungen eingefgt
 2.2	: Fehler mit NOCHANGE und HEX behoben
 2.3	: Parameter auf Standard C= Format umgestellt und ReadArgs fr
	Lesen eingesetzt, dadurch Parameterreihenfolge gendert.
 2.4	: Funktion end jetzt nach Text WieProgrammieren.TXT
 2.5   06.08.95 : Fehler in Funktion Ausgabe (jetzt 1.4) behoben
 2.6   15.10.95 : return-Codes geordnet
 2.7   31.10.95 : kleinere Fehler behoben
 2.8   10.12.95 : Fehler mit PATTERN_BACK behoben
 2.9   25.12.95 : Window-Flags verbessert, jetzt auch Public-Screen tauglich
 2.10  31.12.95 : Oeffnen-Funktion der Includes neu, etwas krzer, FileReq
	statt eigener ASl-Funktion, jetzt Englisch
 2.11  02.02.96 : Schreibfehler in Texten behoben
 2.12  04.02.96 : Fehler mit Strings im GUI behoben
 2.13  05.02.96 : Gadgethandling berarbeitet, Feld mit Gadgets statt
	immer neu suchen!
 2.14  06.02.96 : Fehler in Includes behoben, TestOS eingebaut
 2.15  10.02.96 : eigenes StartUp genutzt --> TestOS entfllt wieder
 2.16  14.02.96 : Fehler behoben ! startete immer GUI (seit 2.15)
 2.17  31.03.96 : Fehler mit Option Position behoben
 2.18  04.05.96 : Fehler mit ReadArgs behoben
 2.19  02.08.96 : Bei CTRL_C Abbruch und FROM == TO, wird Quelle geschrieben
*/
 
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>
#include <dos/dos.h>
#include <dos/dosasl.h>
#include <exec/execbase.h>
#include <pragma/intuition_lib.h>
#include <pragma/gadtools_lib.h>
#include <pragma/dos_lib.h>
#include <pragma/exec_lib.h>
#include "SDI_ASM_protos.h"
#include "SDI_ASM_STD_protos.h"
#include "SDI_protos.h"
#include "SDI_structures.h"
#include "SDI_defines.h"
#include "FileReq.h"
#include "Oeffnen.h"
#include "Change.h"
#include "ChangeGUI.h"
#include "ChangeTexts.h"

struct {
  STRPTR	from;
  STRPTR	sstring;
  STRPTR	to;
  STRPTR	rstring;
  LONG		found;
  LONG		hex;
  LONG		length;
  LONG		nochange;
  LONG		nosize;
  LONG		overwrite;
  LONG		path;
  STRPTR	position
  } args = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

struct RDArgs		*rda		= 0;

struct IntuitionBase	*IntuitionBase	= 0;
struct GfxBase		*GfxBase	= 0;
struct Library		*GadToolsBase	= 0;
struct Library		*UtilityBase	= 0;
ULONG			DosVersion	= 37;	// zwingt OS 37
UBYTE			OpenMode	= 0;

struct Screen		*Scr		= 0;
APTR			VisualInfo	= 0;
struct Window		*ChangeWnd	= 0;
struct Gadget		*ChangeGList	= 0;
struct IClass		*getClass	= 0;
struct _Object		*getImage	= 0;
struct TagItem		_TagItem;

extern struct ExecBase	*SysBase;

UWORD	 str[2][BACK_MAX]; // umgew. strings
ULONG             l[2]; // Lnge der Strings
struct SDI_InOut in = {0, 0, 0, 0, 0}, out = {0, 0, 0, 0, 0};

/* ================================ main =============================== */

void main(void)
{
  ULONG h, i; // Hilfsvariablen

  if(((struct Process *) SysBase->ThisTask)->pr_Arguments[1] == 0)
    wbmain();

  if(!(rda = (struct RDArgs *) AllocDosObject(DOS_RDARGS, 0)))
    End(RETURN_FAIL);
  rda->RDA_ExtHelp = TEXT_CLI_HELP;
  if(!ReadArgs(PARAM, (LONG *) &args, rda))
    End(RETURN_FAIL);

  for(i = 0; i < 2; i++)                // bestimmt Strings und deren Lnge
    l[i] = (HEX ? GetCharHEX(*(&args.sstring+2*i), str[i]) :
    GetCharSTRING(*(&args.sstring+2*i), str[i]));
  // *(&args.sstring+2*i) ist eine etwas unnormale Formulierung !
  // sie funktioniert nur, wenn args.rstring immer 2 Positionen hinter
  // args.sstring ist, da ich auf die Strukturelemente, wie auf ein Feld
  // zugreife
#ifdef DEBUG
  PutStr("Strings umgerechnet\n");
#endif

  if((!NOCHANGE && !args.to) || (l[0] == 0))
  {
    SetIoErr(ERROR_REQUIRED_ARG_MISSING); End(RETURN_FAIL);
  }
  h = 0;
  if(NOCHANGE && !(in.file = Open(args.from, MODE_OLDFILE)) ||     // Files
  (!NOCHANGE && !(OpenMode = Oeffnen(args.from, args.to, (char *) 0, &in,
  &out))))
    End(RETURN_FAIL);					  // ffnen
  if(OpenMode == OEFFNEN_WITH_SLASH)
  {
    PutStr(TEXT_NAME_OF_DEST); PutStr(args.from); PutStr("_\n");
  }
#ifdef DEBUG
  PutStr("Files geffnet, Puffer allociert\n");
#endif
  if(NOCHANGE)
  {
    if(!Puffer(&in, &out, args.from))
      End(RETURN_FAIL);
    Eingabe(&in);
#ifdef DEBUG
  PutStr("NOCHANGE: Puffer allociert, eingelesen\n");
#endif
  } /* End of if(NOCHANGE) */
  for(h = 0; h < 2; ++h)
  {
    PutStr(h == 0 ? TEXT_SEARCH_STR : TEXT_REPLACE_STR);
    for(i = 0; i < l[h]; ++i)			     // Ausgabe der Strings
      if(str[h][i] == PATTERN_BACK)
      {
        PutStr("\033[7m");
        FPutC(Output(), PATTERN_BACK);
        PutStr("\033[27m");
      }
      else if(SDI_isprint(str[h][i]))
        FPutC(Output(), str[h][i]);
      else
        PutStr("\033[7m.\033[27m");
      PutStr("'\n");
    if(NOCHANGE) break;
  } /* End of for(h=0; ...) */
  Tausch((unsigned long) (POSITION ? SDI_strtoul(args.position, 0, 16) : 0));
  End(RETURN_OK);
}

/* =============================== wbmain ============================== */

extern "C" void wbmain(void)
{
  struct IntuiMessage  *msg;
  STRPTR in_str[2] = {0, 0};	// Original-Strings
  UBYTE out_str[2][BACK_MAX];	// Ausgabe-Strings
  ULONG 		 fh;	// Ausgabe-Filehandle
  ULONG		       i, j;	// Hilfsvariable
  STRPTR	     quelle;	// Zeiger auf Namen von Dateien
  ULONG		     _Class;	// IDCMP-Klasse fr Gadget-Auswertung
  struct Gadget   *gadg = 0;

  version += 6; // kill $VER:

  if(
  !(IntuitionBase = (struct IntuitionBase *) OpenLibrary("intuition.library", 37)) ||
  !(GadToolsBase = OpenLibrary("gadtools.library", 37)) ||
  !(GfxBase = (struct GfxBase *) OpenLibrary("graphics.library", 37)) ||
  !(UtilityBase = OpenLibrary("utility.library", 37)) ||
  !(Scr = LockPubScreen(0)) ||
  !(VisualInfo = GetVisualInfoA(Scr, 0)) ||
  !(getClass = initGet()) ||
  !(getImage = (struct _Object *) NewObject(getClass, NULL, GT_VisualInfo, VisualInfo, TAG_DONE )) ||
  OpenChangeWindow()
  )
    End(RETURN_FAIL);
  in_str[0]=((struct StringInfo *) GDAT_Search_String->SpecialInfo)->Buffer;
  in_str[1]=((struct StringInfo *)GDAT_Replace_String->SpecialInfo)->Buffer;

  do
  {
    _Class = 0;
    if(Wait((1L<<ChangeWnd->UserPort->mp_SigBit)|SIGBREAKF_CTRL_C)
    == SIGBREAKF_CTRL_C)
      _Class = IDCMP_CLOSEWINDOW;
    else
    {
      msg = GT_GetIMsg(ChangeWnd->UserPort);
      _Class = msg->Class;
      gadg = (struct Gadget *) msg->IAddress;
      GT_ReplyIMsg(msg);
    }

    switch(_Class)
    {
    case IDCMP_GADGETUP:
      if((i = gadg->GadgetID) >= GD_FOUND_CheckBox &&
      i <= GD_POSITION_CheckBox)
        *(&args.found + i - GD_FOUND_CheckBox) =
        (gadg->Flags & GFLG_SELECTED);
      // *(&args.found + i - GD_FOUND_CheckBox) wacklige Konstruktion, da
      // wie in main die Struktur als Feld behandelt wird
      // nur, wenn CheckBox-Gadgets in der richtigen Reihenfolge
      switch(i)
      {
      case GD_Search_String: case GD_Replace_String:
        j = gadg->GadgetID - GD_Search_String;
        in_str[j] = ((StringInfo *)gadg->SpecialInfo)->Buffer;
	((StringInfo *)gadg->SpecialInfo)->BufferPos = 0;
        l[j] = (HEX ? GetCharHEX(in_str[j], str[j]) :
        GetCharSTRING(in_str[j], str[j]));
        for(i = 0; i < l[j]; ++i)
          out_str[j][i] = str[j][i];
        out_str[j][i] = '\0';
        ((struct StringInfo*) gadg->SpecialInfo)->Buffer = (STRPTR)
          out_str[j];
        Refresh(gadg);
        break;
      case GD_Load_File_String:
      case GD_Save_File_String:
	((StringInfo *)gadg->SpecialInfo)->BufferPos = 0; Refresh(gadg);
	break;
      case GD_Load_File_GetFile: case GD_Save_File_GetFile:
        gadg = ChangeGadg[GD_Load_File_String + gadg->GadgetID];
	FileReq(((StringInfo *)gadg->SpecialInfo)->Buffer,
	  ((StringInfo *)gadg->SpecialInfo)->MaxChars, FILEREQ_MODE_OPEN,
	  TEXT_CHOOSE_A_FILE);
        Refresh(gadg);
        break;
      case GD_POSITION_CheckBox:
        ToogleGadgStat(GDAT_Position_String, (ULONG) !POSITION); break;
      case GD_LENGTH_CheckBox: case GD_PATH_CheckBox:
      case GD_OVERWRITE_CheckBox:
        PATH = OVERWRITE = LENGTH = 0;
        *(&args.found + i - GD_FOUND_CheckBox) =
          (gadg->Flags & GFLG_SELECTED);
        (GDAT_OVERWRITE_CheckBox->Flags) = (GDAT_OVERWRITE_CheckBox->Flags
          & ~GFLG_SELECTED) + (OVERWRITE ? GFLG_SELECTED : 0);
        (GDAT_PATH_CheckBox->Flags) = (GDAT_PATH_CheckBox->Flags
          & ~GFLG_SELECTED) + (PATH ? GFLG_SELECTED : 0);
        (GDAT_LENGTH_CheckBox->Flags) = (GDAT_LENGTH_CheckBox->Flags
          & ~GFLG_SELECTED) + (LENGTH ? GFLG_SELECTED : 0);
        RefreshA();
        break;
      case GD_NOCHANGE_CheckBox:
        ToogleGadgStat(GDAT_FOUND_CheckBox, (ULONG) NOCHANGE);
        ToogleGadgStat(GDAT_LENGTH_CheckBox, (ULONG) NOCHANGE);
        ToogleGadgStat(GDAT_OVERWRITE_CheckBox, (ULONG) NOCHANGE);
        ToogleGadgStat(GDAT_PATH_CheckBox, (ULONG) NOCHANGE);
        ToogleGadgStat(GDAT_POSITION_CheckBox, (ULONG) NOCHANGE);
        ToogleGadgStat(GDAT_Position_String,
        (ULONG) (NOCHANGE || !POSITION));
        ToogleGadgStat(GDAT_Save_File_String, (ULONG) NOCHANGE);
        ToogleGadgStat(GDAT_Replace_String, (ULONG) NOCHANGE);
        break;
      case GD_START_Button:
        if(l[0] == 0)
          { TextOut(TEXT_NO_SEARCH_STRING); break; }
        quelle = ((StringInfo *)GDAT_Load_File_String->SpecialInfo)->Buffer;
        i = 0;				// Wichtig fr ffnens 2. Para.
        if(NOCHANGE && !(in.file = Open(quelle, MODE_OLDFILE)) ||
        (!NOCHANGE && !(OpenMode = Oeffnen(quelle, ((StringInfo *)
        GDAT_Save_File_String->SpecialInfo)->Buffer, 0, &in, &out))))
        {
          if(in.file)
            Close(in.file);
          if(out.file)
            Close(out.file);
          if(in.buf)
            Free(&in);
          if(out.buf)
            Free(&out);
          in.file = out.file = 0;
          TextOut(TEXT_CANT_OPEN_FILE);
          break;
        }
        if(OpenMode == OEFFNEN_WITH_SLASH)
          TextOut(TEXT_SLASH_AT_END);
        if (NOCHANGE)
        {
          if(!Puffer(&in, &out, quelle))
          {
            Close(in.file); in.file = 0;
	    Fault(ERROR_NO_FREE_STORE, 0, texts_fault, TEXT_FAULT_SIZE);
            TextOut(texts_fault);
            break;
          }
          Eingabe(&in);
        }
        if(!(fh = Open("CON:0/11/640/190/Change Report/WAIT/CLOSE",
        MODE_NEWFILE)))
        {
          TextOut(TEXT_CANT_OPEN_REPORT_WINDOW);
          fh = Open("NIL:", MODE_NEWFILE);
        }
        SelectOutput((BPTR) fh);
        Tausch(SDI_strtoul(((StringInfo *) GDAT_Position_String->SpecialInfo)
        ->Buffer, 0, 16));
        FOUND = (GDAT_FOUND_CheckBox->Flags & GFLG_SELECTED);
        LENGTH = (GDAT_LENGTH_CheckBox->Flags & GFLG_SELECTED);
        OVERWRITE = (GDAT_OVERWRITE_CheckBox->Flags & GFLG_SELECTED);
        POSITION = (char *) (GDAT_POSITION_CheckBox->Flags & GFLG_SELECTED);
        PATH = (GDAT_PATH_CheckBox->Flags & GFLG_SELECTED);
        Close(fh); Close(in.file); in.file = 0;
        if(out.file) { Close(out.file); out.file = 0; }
        Free(&in); Free(&out);
        break;
      } /* End of switch(...) */
      break;
    case IDCMP_GADGETDOWN:
      switch(gadg->GadgetID)
      {
      case GD_Search_String: case GD_Replace_String:
        j = gadg->GadgetID - GD_Search_String;
        ((StringInfo*) gadg->SpecialInfo)->Buffer = (STRPTR) in_str[j];
        Refresh(gadg);
        break;
      }
      break;
    } /* switch(_Class) */
    while((msg = GT_GetIMsg(ChangeWnd->UserPort)))
      GT_ReplyIMsg(msg);
  } while(_Class != IDCMP_CLOSEWINDOW);
  ((StringInfo*) GDAT_Search_String->SpecialInfo)->Buffer =
    (STRPTR) in_str[0];
  ((StringInfo*) GDAT_Replace_String->SpecialInfo)->Buffer =
    (STRPTR) in_str[1];
  End(RETURN_OK);
}

/* ============================== Refresh ============================== */

void RefreshA(void)
{
  RefreshGadgets(GDAT_FOUND_CheckBox, ChangeWnd, 0);
}

void Refresh(struct Gadget *a)
{
  RefreshGList(a, ChangeWnd, 0, 1);
}

/* ============================== TextOut ============================== */

void TextOut(STRPTR text)
{
  _TagItem.ti_Tag = GTTX_Text;
  _TagItem.ti_Data = (ULONG) text;
  GT_SetGadgetAttrsA(GDAT_Error_Text, ChangeWnd, NULL, &_TagItem);
}

/* =========================== ToogleGadgStat ========================== */

void ToogleGadgStat(struct Gadget *gadg, ULONG real)
{
  _TagItem.ti_Tag = GA_Disabled;
  _TagItem.ti_Data = real;
  GT_SetGadgetAttrsA(gadg, ChangeWnd, NULL, &_TagItem);
}

#define c_q (in.count + in.buf - in.pos)
#define l_z (out.size + out.buf - out.pos)
#define qz  str[0]
#define zz  str[1]
#define IF_PATT_BACK(a) (a >= PATTERN_BACK ? PATTERN_BACK : 0)

/* =============================== Tausch ============================== */
/* ====== Ersetzt QuellString aus Quelle durch ZielString in Ziel ====== */

void Tausch (ULONG chpos)
{

  ULONG       zae = 0;  // Zhler
  LONG          p = 0;  // <> 0 - bis Null warten 0 - nicht
  ULONG    Stelle = 0;  // Stelle + in.pos - in.buf -> Position
  ULONG        st = 0;  // Stelle der berprfung
  ULONG founddata[2] = {0, 0};
  UBYTE Ausg_Soll = 0; // 0 = found, 1 = gewechselt (Soll)
  UBYTE Ausg_Ist  = 2; // 0 = found, 1 = gewechselt (Ist)
  ULONG           max;  // maximale Fllung von z
  STRPTR	    m;  // verkrzt Schleife (Bearbeitungszeit)
  UBYTE both_first_same; // bei zwei gleichen ersten Zeichen 1
  UBYTE        ff = 0;  // Anzahl der PATTERN_BACK am Anfang

  if(l[0] == l[1]) OVERWRITE = LENGTH = PATH = 0;            // sind unntz
  if(PATH) OVERWRITE = LENGTH = 0;                   // pat nicht zusammen
  if(OVERWRITE) LENGTH = 0;
  if(NOCHANGE)
  {
    FOUND = 1; POSITION = 0; PATH = OVERWRITE = LENGTH = 0;
  }
#ifdef DEBUG
  if (FOUND)	{PutStr("FOUND     = "); PutNum(FOUND, 2);	PutStr("\n");}
  if (HEX)	{PutStr("HEX       = "); PutNum(HEX, 2);	PutStr("\n");}
  if (LENGTH)	{PutStr("LENGTH    = "); PutNum(LENGTH, 2);	PutStr("\n");}
  if (NOCHANGE) {PutStr("NOCHANGE  = "); PutNum(NOCHANGE, 2);	PutStr("\n");}
  if (NOSIZE)	{PutStr("NOSIZE    = "); PutNum(NOSIZE, 2);	PutStr("\n");}
  if (OVERWRITE){PutStr("OVERWRITE = "); PutNum(OVERWRITE, 2);	PutStr("\n");}
  if (PATH)	{PutStr("PATH      = "); PutNum(PATH, 2);	PutStr("\n");}
  if (POSITION) {PutStr("POSITION  = "); PutNum(chpos, 10);	PutStr("\n");}
#endif

  max = 2 + ((l[1] < l[0]) ? l[0] : l[1]);
  while(ff < l[0] && qz[ff] == PATTERN_BACK)
    { ++ff; *(out.pos++) = *(in.pos++); }
  if (ff == l[0])
    { out.pos = out.buf; in.pos = in.buf; ff = 0; }
  if (l[0] > 1)
    both_first_same = (NOSIZE?SDI_tolower(qz[ff]) == SDI_tolower(qz[ff+1]) :
                               qz[ff] == qz[ff+1]);

  do
  {
#ifdef DEBUG_LOOP
    PutStr("Tausch: Haupt-Schleife\n");
#endif
    if(!st && qz[ff] < PATTERN_BACK)
    {                       // Schleife sucht erstes Zeichen des Suchstring
      m = (c_q < l_z-max ? c_q : l_z-max) + out.pos;
      if(NOSIZE) qz[ff] = SDI_tolower(qz[ff]);    // verkrzt Schleife
      while(m-out.pos && !(p && !(*in.pos)) && (NOSIZE ? SDI_tolower(*in.pos):
      *in.pos) != qz[ff])
        *(out.pos++) = *(in.pos++);
    }
    if(in.pos >= in.buf + in.count)			// Lese-Puffer voll
    {
      Stelle += in.count;
      Eingabe(&in);
#ifdef DEBUG
      PutStr("Tausch: Einlesen\n");
#endif
    }
    if(out.pos >= out.buf + out.size - max)				     // Schreib-Puffer voll
    {
#ifdef DEBUG
      PutStr("Tausch: Ausgeben\n");
#endif
      if(NOCHANGE)
        out.pos = out.buf;
      else
        Ausgabe(&out, ff+1);
    }
    if(in.count)
    {
      if(p && !(*in.pos))			// Pfad-Ausgleich ist aktiv
      {
#ifdef DEBUG
        PutStr("Tausch: Pfad-Ausgleich\n");
#endif
        if(p < 0)
          { ++in.pos; *(out.pos++) = '\0'; }
        for(; p < 0; ++p)
          ++in.pos;
        for(; p > 0; --p)
          *(out.pos++) = '\0';
      }
      while(c_q > 0 && (ff+st) < l[0] && (qz[ff+st] >= PATTERN_BACK ||
        (NOSIZE ? SDI_tolower(*in.pos) == SDI_tolower(qz[ff+st]) :
        *in.pos == qz[ff+st])))  // testet nach Suchstring (ab char 2)
      {
        if(qz[ff+st] >= PATTERN_BACK)
          qz[ff+st] = PATTERN_BACK + *in.pos;
        else if(NOSIZE)
          qz[ff+st] = *in.pos;
        ++st; ++in.pos;
      }
    }
    if(st)
    {
#ifdef DEBUG
      PutStr("Tausch: Zielstring gefunden\n");
#endif
      if(ff)         // gleicht die bersprungenen PATTERN_BACK wieder aus
      {
        for(zae = ff; zae > 0; --zae)
          qz[zae-1] = PATTERN_BACK + *(--out.pos);
        st += ff;
      }
      if(st == l[0])
      {
#ifdef DEBUG
        PutStr("Tausch: Zielstring ist komplett\n");
#endif
        if(LENGTH && out.pos != out.buf)
          *(out.pos-1) += l[1] - l[0];
        ++founddata[0];	// gefundene Zeichen
        if(!NOCHANGE && (!POSITION || chpos == Stelle-l[0]
            + (in.pos - in.buf)))
        {
#ifdef DEBUG
          PutStr("Tausch: Zielstring wird ersetzt\n");
#endif
          ++founddata[1]; Ausg_Soll = 1; // gewechselte Zeichen
          for(zae = 0; zae < l[1]; ++zae)	    // Zielstring einsetzen
            if(zz[zae] != PATTERN_BACK)
              *(out.pos++) = zz[zae];
            else if(zae < l[0]) 	           // PATTERN_BACK ersetzen
              *(out.pos++) = qz[zae] - IF_PATT_BACK(qz[zae]);
          if(PATH)			      // wenn ntig Pfad anschalten
            p = l[0] - l[1];
          if(OVERWRITE) 		  // berschreiben mit Text oder \0
          {
#ifdef DEBUG
            PutStr("Tausch: Overwrite ist aktiv\n");
#endif
            if(l[0] > l[1])
              for(zae = l[1]; zae < l[0]; ++zae)
                *(out.pos++) = 0;
            else
              *in.pos += (l[1] - l[0]);
          }
        } // if(!NOCHANGE ...)
        else if(POSITION) // gefunden an falscher Position (kein Ersetzen)
          for(zae = 0; zae < l[0]; ++zae)
            *(out.pos++) = qz[zae] - IF_PATT_BACK(qz[zae]);
        if(FOUND)				// Ausgabe bei Option FOUND
        {
          if(Ausg_Soll != Ausg_Ist && Ausg_Ist != 2)
            PutStr("\n");
          if(Ausg_Soll == 0 && Ausg_Ist != 0)
          {
            PutStr(TEXT_STRING_FOUND_AT);
            Ausg_Ist = 0;
          }
          else if(Ausg_Soll == 1 && Ausg_Ist != 1)
          {
            PutStr(TEXT_STRING_CHANGED_AT);
            Ausg_Ist = 1;
          }
          zae = Stelle - l[0] + (in.pos - in.buf);
	  VPrintf(" %lx", &zae);
          Ausg_Soll = 0;
        } // if (FOUND)
        st = 0;
      } // if (st == l[0])
      else
      {
#ifdef DEBUG
        PutStr("Tausch: Zielstring ist nicht komplett, wird nicht ersetzt\n");
#endif
        if(st > 1 && both_first_same) 	// wenn erste zwei Zeichen gleich mit einem
	{
#ifdef DEBUG
	  PutStr("Tausch: Beide erste gleich? Neuer Test mit Versatz.\n");
#endif
          for(zae = 1; zae < st && (qz[zae-1] >= PATTERN_BACK ||
          (NOSIZE ? SDI_tolower(qz[zae-1]) == SDI_tolower(qz[zae] -
          IF_PATT_BACK(qz[zae])) : qz[zae-1] ==  qz[zae] -
          IF_PATT_BACK(qz[zae]))); ++zae)
          ;				    // Versatz von 1 nochmal testen
	}
        if(st > 1 && both_first_same && zae == st)
        {
#ifdef DEBUG
	  PutStr("Tausch: Versatz scheint zu stimmen!\n");
#endif
           *(out.pos++) = qz[0] - IF_PATT_BACK(qz[0]);
           for(st = 1; st < zae; ++st)
           qz[st-1] = qz[st] - IF_PATT_BACK(qz[st])
           + IF_PATT_BACK(qz[st-1]);
           --st;
	   if(ff)
	   {
	     for(zae = 0; zae < ff; ++zae)
	       *(out.pos++) = qz[zae] - IF_PATT_BACK(qz[0]);
	     st -= ff;
	   }
         }
        else
        {
#ifdef DEBUG
	  PutStr("Tausch: Schreibe Teile in Zielpuffer.\n");
#endif
          for(zae = 0; zae < st; ++zae)
            *(out.pos++) = qz[zae] - IF_PATT_BACK(qz[zae]);
          st = 0;
        }
      }
    } // if(st)
  } while(in.count && !CTRL_C);

  if(!NOCHANGE)
    Ausgabe(&out, 0);
  if(CTRL_C && !NOCHANGE && (OpenMode == OEFFNEN_BOTH_SAME || OpenMode ==
  OEFFNEN_BOTH_SAME_BY_SECOND_EMPTY))
  {
    Seek(out.file, 0, OFFSET_BEGINNING);
    Write(out.file, in.buf, in.size);
  }

  if(!CTRL_C)
  {
    if(FOUND)
      PutStr("\n");
    VPrintf(TEXT_STATUS_OUTPUT, &founddata);
  }
}

/* ================================ End ================================ */

void end(void)
{
  if(ChangeWnd) 	CloseWindow(ChangeWnd);
  if(ChangeGList)	FreeGadgets(ChangeGList);
  if(getImage)		DisposeObject(getImage);
  if(getClass)		FreeClass(getClass);
  if(VisualInfo)	FreeVisualInfo(VisualInfo);
  if(Scr)		UnlockPubScreen(0, Scr);
  if(rda)
  {
    FreeArgs(rda);
    FreeDosObject(DOS_RDARGS, rda);
  }
  if(in.file)		Close(in.file);
  if(out.file)		Close(out.file);
  Free(&in);
  Free(&out);
  if(UtilityBase)	CloseLibrary(UtilityBase);
  if(GfxBase)		CloseLibrary((struct Library *) GfxBase);
  if(GadToolsBase)	CloseLibrary(GadToolsBase);
  if(IntuitionBase)	CloseLibrary((struct Library *) IntuitionBase);
}
