/*
 *  GETKEY.H
 *
 *  (c)Copyright 1990 by Tobias Ferber,  All Rights Reserved.
 */

#ifndef GETKEY_H
#define GETKEY_H

/* The prototype */

#if defined (__STDC__) || defined (__cplusplus)
extern int getkey(void);
#else /* !(__STDC__ || __cplusplus) */
extern int getkey();
#endif /* __STDC__ || __cplusplus */

/*
 * Some compilers come up with their own getkey() routines.
 * Please feel free to add them in here:
 */

#ifdef __TURBOC__
#include <conio.h>
#define getkey() getch()
#endif /* __TURBOC__ */

/*
 * Some machines can read from non-buffered stdin. (e.g. MS-DOS machines
 * can do so if "con" is opened in _binary_ mode.)
 * If so, please add your console ``file'' name in here:
 */

#if defined(__MSDOS__) || defined(GNUDOS)
#define CONSOLENAME "con"

#elif defined(AMIGA)

/* The name parameter for Amiga dos.library's Open() can be "*",
 * representing current window.  Note that as of V36, "*" is obsolete,
 * and CONSOLE: should be used instead.
 */

#define CONSOLENAME "*"

#elif defined(MINT)
#define CONSOLENAME "/dev/tty"

#endif /* machines and their console names */


#endif /* !GETKEY_H */
