#include <arpbase.h>
#include <arp_proto.h>
#include "Launch.h"
#include "LaunchPriv.h"


/*
 *	NAME
 *		CheckKill -- check if someone tried to kill you off.
 *
 *	SYNOPSIS
 *		bool = CheckKill ()
 *
 *		BOOL CheckKill (void);
 *
 *	DESCRIPTION
 *		Check if the KILL_PROCESS_FLAG has been raised.
 *
 *	INPUT
 *		None.
 *
 *	OUTPUT
 *		bool - non-zero if you were killed.
 *
 *	NOTE
 *		Currently, we use the break C signal to kill.
 *
 *	HISTORY
 *		1992/09/06	Pierre Baillargeon		Creation
 *
 *	SEE ALSO
 *		KillProcess(), KillProcesses()
 */

BOOL CheckKill (void)
{
	if (SetSignal (0L, 0L) & KILL_PROCESS_FLAG)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}
