/*
 *	Functions to manage sub-process in a program.
 *
 *	You can launch processes running on your code, and these processes
 *	can also launch other processes.
 *
 *	You MUST call WaitProcesses() before exiting if you have launched other
 *	processes.  This necessary for ALL process that launch others.
 *
 */

extern struct ArpBase *ArpBase;

#define KILL_PROCESS_FLAG	SIGBREAKF_CTRL_C

struct Process *StartProcess (char *Name, CPTR EntryPoint, void *Data, WORD Pri);
void KillProcess (struct Process *);
void KillProcesses (void);
void WaitProcess (struct Process *);
void WaitProcesses (void);
BOOL CheckKill (void);
BOOL CheckAlive (struct Process *);
void FlushProcesses (void);
