/*  $VER: FTrans.rexx 1.3 (Jul 15 1995)
 *
 *  Arexx-Script fr FTrans Arexx-Interface (c) Copyright 1993/94
 *  by Rainer Hess
 *
 *  May 21 1993, Oct 22 1993, Dec 21 1993, Dec 26 1993, Dec 30 1993
 *  Dec 31 1993, Jan  3 1994, Jul 15 1995
 *
 *  V1.1 - Neuer FTrans ARexx-Befehl WORTARG eingefgt.
 *  V1.2 - ARexx-Port-Name fr FTrans V1.7 gendert.
 *  V1.3 - Neuer FTrans ARexx-Befehl VERSION, REVISION, FLUSHBUFFER,
 *         ZIPWINDOW und VERSTAG eingefgt.
 */

options results

/*
 * Wir definieren unsere Eingabe und Ausgabedatei, ebenso unseren
 * Publicscreen. Diese brauchen wir spter in diesem Arexx-Script.
 *
 * ACHTUNG! Die Eingabedatei die in 'indat' initialisiert wird sollte
 * existieren da wir sonst eine Fehlermeldung bekommen. Ebenso sollte
 * der Publicscreen vorhanden sein, geht aber auch ohne.
 */

indat  = "RAM:AlteTextDatei"
outdat = "RAM:NeueTextDatei"

newpubscreenname = "CygnusEdScreen1"

/*
 * rexxsupport.library einbinden.
 */

if ~show('l',"rexxsupport.library") then do
   call addlib 'rexxsupport.library',0,-30,0
   if (result = 0) then do
     say "Die rexxsupport.library kann nicht eingebunden werden!"
     say "Evtl. ist die rexxsupport.library nicht installiert..."
     exit
   end
end

/*
 * Luft unser Ftrans mit ARexx-Port "FTRANS.1"?
 */

ok = show("P","FTRANS.1")
if ok = 0 then do
   say 'Entschuldigung, das Programm FTrans mit Arexx-Port FTRANS.1 luft nicht!'
   exit 0
end

/*
 *  Text auf das Shell-Fenster ausgeben in dem
 *  der Arexx-Script gestartet wurde.
 */

say ' - Start...'
say

/*
 * Arexx-Port aktivieren.
 */

address 'FTRANS.1'

/*
 * Ausgabe-Texte lschen.
 */

FLUSHBUFFER

/*
 * FTEcho "ON" gibt Informationen im Info-Fenster von FTrans aus.
 * FTEcho "OFF" wuerde dies unterbinden.
 */

FTEcho "on"
say "-> FTEcho ist" result
say

/*
 * Lock GUI
 */

LOCKGUI

/*
 * Nun einen Text auf das Info-Fenster von FTrans ausgeben.
 * Danach 1 Sekunde (50 Ticks = 1 Sekunde) warten.
 */

Message "Hallo ich soll Dich von FTrans informieren..."
ok = delay(50)

/*
 * Versions, Revisions und Verstag-Ausgabe:
 */

VERSION
say 'Die aktuelle Programmversion ist:' result

REVISION
say 'Die aktuelle Programmrevision ist:' result

VERSTAG
say 'Die aktuelle Programmversion ist:' result

/*
 * So nun das Fenster "zippen" kurz warten und wieder "dezippen".
 */

ZIPWINDOW
ok = delay(2 * 50)
ZIPWINDOW

/*
 * Nun Wechseln wir die bersetzungsart. Was dann aktiviert
 * ist bekommen wir als Text zurckgeliefert (TEXT oder WORT).
 * Danach wieder 1 Sekunde warten. Einfach so zum berblick...
 */

Wechsel
say "-> Wechsel, nun aktive bersetzung:" result
ok = delay(50)

/*
 * Nun bersetzen wir den Text von Datei indat und der Datei outdat.
 * Sollte eine Datei nicht gefunden werden, bekommen wir einen Fehler!
 */

say
say "-> bersetze" indat "nach" outdat
FTTEXT indat outdat
say "-> FTText:" result

/*
 * Nun ein Wort von der Shell abholen.
 */

say
options prompt "-> Bitte ein Wort eingeben: "
parse pull eingabe

/*
 * Das Wort in eine Datei schreiben von dort aus kann es Ftrans bernehmen.
 */

ok = open("DateiName", "t:FTransEingabe", "W")
ok = writech( "DateiName", eingabe )
ok = close("DateiName")

/*
 * FTrans holt das Wort aus der Datei und sucht im Wrter nach der bersetzung.
 * Wurde es nicht gefunden steht es in den geschweiften Blockklammern { und }.
 */

Wort "t:FTransEingabe"
say "                  Ergebnis:" result

/*
 * Nun wird der Dos-Befehl Delete ausgefhrt. Dieser sollte sich im C:
 * Direktorie befinden. Ist er da wird die bergabedatei gelscht.
 */

if exists('c:delete') then
  address command 'c:delete' ">NIL: t:FTransEingabe"
else say 'Dos-Befehl c:Delete ist nicht zu finden...'


/*
 * Arexx-Port wieder aktivieren.
 */

address 'FTRANS.1'

/*
 * Den alten Publicscreen merken.
 */

say
OLDPUBLICSCREEN
oldpub=result
say "-> Alter PublicScreen:" oldpub

/*
 * Den neuen Publicscreen setzen.
 */

say
PUBLICSCREEN newpubscreenname
say "-> Neuer PublicScreen:" result

/*
 * Und den alten wieder verwenden.
 */

say
PUBLICSCREEN oldpub
say "-> Alter PublicScreen:" result

/*
 * Aktuelles Wterbuch deaktivieren
 * (und 5 Sekunden warten, um es besser beobachten zu knnen)
 */

say
DELOAD
say "-> Wrterbuch deaktiviert"
ok = delay(5 * 50)

/*
 * Aktuelles Wterbuch reaktivieren
 */

say
RELOAD
say "-> Wrterbuch reaktiviert"

/*
 * Lernbuffer lschen
 */

say
LERNFLUSH
say "-> Lernbuffer gelscht"

/*
 * Merkbuffer lschen
 */

say
MERKFLUSH
say "-> Merkbuffer gelscht"

/*
 * Nun ein Wort von der Shell abholen.
 */

say
options prompt "-> Bitte ein Wort eingeben: "
parse pull eingabe

/*
 * FTrans holt das Wort als Argument direkt ab. Wurde das Wort nicht
 * gefunden steht es in den geschweiften Blockklammern { und }.
 */

WortArg eingabe
say "                  Ergebnis:" result

/*
 * Den Zustand des Autolern-Modus berprfen.
 */

say
AUTOLERNEN
say 'Das Autolernen ist' result

/*
 * Den Zustand des Clipboard-Modus berprfen.
 */

say
CLIPBOARD
say 'Das Clipboard ist' result

/*
 * Den Zustand des Inforrequester-Modus berprfen.
 */

say
INFOREQUESTER
say 'Info-Requester ist' result

/*
 * Den Zustand des Vorschlag-Modus berprfen.
 */

say
VORSCHLAG
say 'Vorschlge sind' result


/*
 * Eine letzte Information auf das Info-Fenster von FTrans ausgeben.
 */

Message "--- Danke das war's - FTrans Arexx-Script beendet ---"

/*
 * Und ebenfalls noch eine letzte Meldung auf das Shell-Fenster.
 */

say
say "   *** Danke das war's - FTrans Arexx-Script beendet. ***"

/*
 * Unlock GUI
 */

UNLOCKGUI

/*
 * Script Ende, alles ok.
 */

exit 0
