/*
 * hold.h - common definitions to all Hold modules
 *
 * Bruno Costa - 16 Sep 89 - 19 Jan 91
 *
 */

#define ON  1
#define OFF 0

struct handlerdata {  /* static flags for the handler */
 int activate;
 int hold;
 int ignore;
 int actbit;
 ULONG actmask;
 struct Task *task;
 int count;
 int activated;
 int maxtime;
 struct InputEvent event;
};

#define DCLICKERR 5	/* max distance allowed between double clicks */

#define MAXTIME 1	/* # of timer events to wait until window activation */

#define TASKNAME "Hold_1.43b"
#define PORTNAME "HoldPort"

#define KILLMSG "\x1b[1mHold\x1b[0m: terminating ...\n"
#define NOKILLMSG "\x1b[1mHold\x1b[0m: not installed.\n"
#define ALREADY "\x1b[1mHold\x1b[0m: already installed.\n"

#define BANNER "\x1b[0;33mHold v1.43b\x1b[0m - Copyright \xa9 1991 by Bruno Costa\n"
#define USAGE "usage: \x1b[1mHold\x1b[0m [-a] [-h] [-q]\n"

struct Window *WhichWindow (void);
struct InputEvent * __far __saveds C_handler (	struct InputEvent *head,
						struct handlerdata *data );
