/*
 *   Includes for minrexx.c; please refer to that file for
 *   further documentation.
 */
#include <rexx/rxslib.h>

/*
 *   Although not declared in minrexx.c, these prototype/pragmas are
 *   listed here because they aren't listed in any standard includes!
 */
struct RexxMsg * CreateRexxMsg(struct MsgPort *, char *, char *);
#pragma libcall RexxSysBase CreateRexxMsg 90 9803
void DeleteRexxMsg(struct RexxMsg *);
#pragma libcall RexxSysBase DeleteRexxMsg 96 801
char * CreateArgstring(char *, int);
#pragma libcall RexxSysBase CreateArgstring 7E 802
void DeleteArgstring(char *);
#pragma libcall RexxSysBase DeleteArgstring 84 801

/*
 *   Maximum messages that can be pending, and the return codes
 *   for two bad situations.
 */
#define MAXRXOUTSTANDING (300)
#define RXERRORIMGONE (100)
#define RXERRORNOCMD (30)

/*
 *   This is the association list you build up (statically or
 *   dynamically) that should be terminated with an entry with
 *   NULL for the name . . .
 */
struct rexxCommandList 
{
   char *name ;
   void (*userdata)(struct RexxMsg *, char *) ;
};

long upRexxPort (char *s, struct rexxCommandList *rcl, char *exten, void(*uf)(struct RexxMsg *, struct rexxCommandList *, char *));
void dnRexxPort (void);
void dispRexxPort (void);
struct RexxMsg *sendRexxCmd (char *s, void (*f)(struct RexxMsg *), STRPTR p1, STRPTR p2, STRPTR p3);
struct RexxMsg *asyncRexxCmd (char *s);
struct RexxMsg *syncRexxCmd (char *s, struct RexxMsg *msg);
void replyRexxCmd (struct RexxMsg *msg, long primary, long secondary, char *string);
struct RexxMsg *sendSimpleCmd (char *s, char *host, void (*f)(struct RexxMsg *), STRPTR p1, STRPTR p2, STRPTR p3);
