
NAME

	Dir


FORMAT

	DIR [<dir|pattern>] [OPT A|I|AI|D|F] [ALL] [DIRS] [FILES] [INTER]


PURPOSE

	To display a sorted list of the files in a directory.


SPECIFICATION

	DIR displays the file and directory names contained in the specified
	directory, or the current directory if no name is given.  Directories
	are listed first, followed by an alphabetical list of the files in
	two columns.  Pressing Ctrl-C aborts a directory listing.


OPTIONS

	ALL		Displays all subdirectories and their files.
	DIRS		Displays only directories.
	FILES		Displays only files.
	INTER		Enters an interactive mode.

	Note:  	The ALL, DIRS, FILES and INTER keywords supersede the
		OPT A, D, F and I options, respectively.  The older 
		keywords are retained for compatibility with earlier
		versions of AmigaDOS.  Do not use OPT with the full keywords
		ALL, DIRS, FILES, INTER.

	The interactive listing mode stops after each name and displays a
	question mark at which you can enter commands.  Responses are shown
	below:
	
		Return		Displays the next name on the list.
		E		Enters a directory; the files in that
				directory will be displayed.
		B		Goes back one directory level.
		DEL or DELETE	Deletes a file or empty directory.
		T		Types the contents of a file.
		C or COMMAND	Allows you to enter additional AmigaDOS
				commands.
		Q		Quits interactive editing.
		?		Displays a list of the available
				interactive-mode commands.  

	The COMMAND option allows almost any AmigaDOS command to be executed
	during the interactive directory list.  When you want to issue a
	command, type C (or COM) at the question-mark prompt.  DIR will ask
	you for the command.  Type the desired command, then press Return.
	The command willbe executed and DIR will continue.  You can also combine
	the C and the command on one line, by putting the command in quotes
	following the C.

	For instance, C "type prefs.info HEX" is equivalent to pressing Q to
	exit interactive listing mode and return to a regular Shell prompt and
	typing: TYPE prefs.info HEX.
	
	Note:	It is dangerous to format a disk from the DIR interactive mode,
		as the format will take place immediately, without any
		confirmation requesters appearing.  Also, starting another
		interactive DIR from interactive mode will result in garbled
		output.


EXAMPLES

	1> DIR Workbench2.0:
	displays a list of the directories and files on the Workbench2.0 disk.

	1> DIR MyDisk:#?.memo
	displays all the directories and files on MyDisk that end in .memo.


BUGS

	NONE.


AUTHOR

	Commodore Business Machines.  This program is provided with your Amiga 
	Workbench disks.  It can be found in your C: directory.


COPYRIGHT NOTICE

	This man page was written by:

	Markus Hillenbrand
	Hauptstrasse 6
	36124 Eichenzell-Loeschenrod
	Germany
	
	E-mail: m_hillen@informatik.uni-kl.de


SEE ALSO

	List (AmigaDOS), ls (UNIX-like)
