
NAME

	List


FORMAT

	LIST [{<dir|pattern>}] [P|PAT <pattern>] [KEYS] [DATES] [NODATES]
	     [TO <name>] [SUB <string>] [SINCE <date>] [UPTO <date>]
	     [QUICK] [BLOCK] [NOHEAD] [FILES] [DIRS] [LFORMAT <string>]
	     [ALL]


PURPOSE

	To list information about directories and files.


SPECIFICATION

	LIST displays information about the contents of the current 
	directory.  If you specify a <dir>, <pattern>, or <filename>
	argument, LIST will display information about the specified
	directory, all directories or files that match the pattern, or
	the specified file, respectively.


OPTIONS

	Unless other options are specified, LIST displays the following:

	name		The name of the file or directory.
	size		The size of the file in bytes. If there is
			nothing in this file, the field will read empty.
			For directories, this entry reads Dir.
	protection	The protection bits that are set for this file
			are shown as letters. The clear (unset) bits are
			shown as hyphens. Most files will show the
			default protection bits, rwed for
			readable/writable/executable/deleteable. See the
			PROTECT command for more on protection bits.			
	date and time	The date and time the file was created or last
			altered.
	comment		The comment, if any, placed on the file using the
			FILENOTE command. It is preceded by a colon (:).


	LIST has options which will change the way the output is displayed.
	These options are explained below:

	KEYS		Displays the block number of each header or
			directory.
	DATES		Displays dates in the form DD-MMM-YY (the default
			unless you use QUICK).
	NODATES		Will not display date and time information.  
	TO <name>	Specifies an output file or device by default,
			LIST outputs to the current window.
	SUB <string>	Lists only files containing the substring
			<string>.
	SINCE <date>	Lists only files created on or after a certain
			date.
	UPTO <date>	Lists only files created on or before a certain
			date.
	QUICK		Lists only the names of files and directories.
	BLOCK		Displays file sizes in blocks, rather than in
			bytes.
	NOHEAD		Suppresses the printing of the header
			information.
	FILES		Lists files only (no directories).
	DIRS		Lists directories only (no files.)
	LFORMAT		Defines a string to specially format LIST output.
	ALL		Lists all files in directories and sub-
			directories.

	The LFORMAT option modifies the output of LIST and can be used as
	a quick method of generating script files.  When LFORMAT is specified,
	the QUICK and NOHEAD options are automatically selected.  When using
	LFORMAT you must specify an output format specification string; this
	string is incorporated into the resulting output.  If you want the
	output to be saved, you must redirect it to a file by using the >
	operator or specifying a TO file.

	The format for the output format specification string is
	LFORMAT = <string>.  To include the output of LIST in this string,
	use the substitution operator % S.  The path and filename can be made
	part of the string this way.  Whether the path or the filename is
	substituted for an occurrence of % S depends on how many occurrences
	are in the LFORMAT line, and their order, as follows:

	Substituted with each occurrence
	Occurrences of %S    1st       2nd       3rd       4th

		1	     filename
		2	     path      filename
		3            path      filename  filename
		4            path      filename  path      filename

	Some new operators allow you to specify fields to be printed in
	the LFORMAT output. These operators are:

       	%A          	Prints file attributes (protection bits.)
      	%B          	Prints size of file in blocks.
       	%C         	Prints any comments attached to the file.
       	%D          	Prints the date associated with the file.
       	%F          	Prints the complete file parent path,
       	            	regardless of the current directory.
       	%K          	Prints the file KEY block.
       	%L          	Prints the length of file in bytes.
       	%N          	Prints the name of the file.
       	%P          	Prints the file parent path relative to
                   	the current directory.
       	%T          	Prints the time associated with the file.

	You can put a length specifier and/or a justification specifier
	between the percent sign % and the field specifier. 

	
EXAMPLE

	1 > LIST Dirs
 	Monitors       Dir   rwed 27-June-90 11:43:59
	T      	       Dir   rwed Wednesday  11:37:43
	Trashcan       Dir   rwed 21-Jun-90  17:54:20

	Only the directories in the current directory, in this case SYS: are
	listed. (A shortened version of the output is shown above)

	1 > LIST Li#? TO RAM:Libs.file
	LIST will search for any directories or files that start with LI.
	The output of LIST will be sent to the Libs.file in RAM:

	1 > LIST DF0:Documents UPTO 09-Oct-90

	Only the files or directories in the Documents directory of DF0: that
	have not been changed since October 9, 1990 will be listed.


BUGS

	NONE.


AUTHOR

	Commodore Business Machines.  This program is provided with your Amiga
	Workbench disks.  It can be found in your C: directory.


COPYRIGHT NOTICE

        This man page was written by:

	Markus Hillenbrand
	Hauptstrasse 6
	36124 Eichenzell-Loeschenrod
	Germany

	E-mail: m_hillen@informatik.uni-kl.de


SEE ALSO

	Dir (AmigaDOS), Protect (AmigaDOS), FileNote (AmigaDOS), ls (UNIX-like)
