/************************************************************
* MultiUser - MultiUser Task/File Support System				*
* ---------------------------------------------------------	*
* Group Information Management										*
* ---------------------------------------------------------	*
*  Copyright 1993-1994 Geert Uytterhoeven						*
* All Rights Reserved.													*
************************************************************/


#include <proto/exec.h>

#include "Memory.h"
#include "GroupInfo.h"
#include "Server.h"


	/*
	 *		Allocate a GroupInfo Structure
	 *
	 *		Public Library Function
	 */

struct muPrivGroupInfo __asm __saveds *muAllocGroupInfo(void)
{
	return(MAlloc(sizeof(struct muPrivGroupInfo)));
}


	/*
	 *		Free a GroupInfo Structure
	 *
	 *		Public Library Function
	 */

void __asm __saveds muFreeGroupInfo(register __a0 struct muPrivGroupInfo *info)
{
   if (info) {
      FreeV(info->Pattern);
 		Free(info, sizeof(struct muPrivGroupInfo));
	}
}


	/*
	 *		Get Information about a Group
	 *
	 *		Public Library Function
	 */

struct muPrivGroupInfo __asm __saveds *muGetGroupInfo(register __a0 struct muPrivGroupInfo *info,
																		register __d0 ULONG keytype)
{
	return((struct muPrivGroupInfo *)SendServerPacket(muSAction_GetGroupInfo, (LONG)info, keytype, NULL,
																	 NULL));
}
