/************************************************************
* MultiUser - MultiUser Task/File Support System				*
* ---------------------------------------------------------	*
* Miscellaneous Routines												*
* ---------------------------------------------------------	*
*  Copyright 1993-1994 Geert Uytterhoeven						*
* All Rights Reserved.													*
************************************************************/


#include "multiuser.h"


	/*
	 *		Tag structure for easy tag interpreting
	 */

struct muTags {
	BPTR Input;
	BPTR Output;
	STRPTR PubScrName;
	struct Task *Task;
	STRPTR UserID;
	STRPTR Password;
	ULONG DefProtection;
	BOOL Graphical;
	BOOL Own;
	BOOL Global;
	BOOL Quiet;
	BOOL All;
	BOOL NoLog;
};


	/*
	 *		Function Prototypes
	 */


extern BOOL Init(void);
extern BOOL CleanUp(void);
extern ULONG __asm muOBSOLETE(void);
extern BOOL __asm __saveds muFSRendezVous(register __a6 struct muBase *muBase);
extern BPTR __asm __saveds muGetPasswdDirLock(void);
extern BPTR __asm __saveds muGetConfigDirLock(void);
extern BOOL InterpreteTagList(struct TagItem *taglist, struct muTags *tags);
extern void Warn(STRPTR msg, APTR argarray);
extern void Die(STRPTR msg, ULONG code);
extern STRPTR Encrypt(STRPTR buffer, STRPTR pwd, STRPTR userid);


	/*
	 *		For debugging
	 */

void kprintf(STRPTR fmt,...);
