/************************************************************
* MultiUser - MultiUser Task/File Support System				*
* ---------------------------------------------------------	*
* Server Process															*
* ---------------------------------------------------------	*
*  Copyright 1993-1994 Geert Uytterhoeven						*
* All Rights Reserved.													*
************************************************************/


#include "multiuser.h"


	/*
	 *		Server Process Definitions
	 */

#define SERVERPRI			(4)
#define SERVERSTACK		(4000)
#define SERVERNAME		"MultiUser.server"


	/*
	 *		Private Server Packet
	 */

struct muSPacket {
	struct Message Msg;
	LONG Type;						/* See definitions below */
	LONG Arg1;
	LONG Arg2;
	LONG Arg3;
	LONG Arg4;
	LONG Res1;
};

#define muSAction_Quit				0			/* Server Quit */
#define muSAction_CheckUser		1			/* Login User */
#define muSAction_Passwd			2			/* Change User Password */
#define muSAction_GetUserInfo		3			/* Get User Information */
#define muSAction_CheckPasswd		4			/* Check Password */
#define muSAction_PasswdDirLock	5			/* Get PasswdDirLock */
#define muSAction_ConfigDirLock	6			/* Get ConfigDirLock */
#define muSAction_GetGroupInfo	7			/* Get Group Information */


	/*
	 *		Function Prototypes
	 */


extern struct Process *CreateServer(void);
extern BOOL StartServer(void);
extern BOOL KillServer(void);
extern LONG SendServerPacket(LONG type, LONG arg1, LONG arg2, LONG arg3, LONG arg4);
