
#include "headers.h"

#ifdef DEBUGMODULE
    
    #include "support/debug.h"

#else

    void __stdargs kprintf(UBYTE *fmt,...);  // Serial debugging...
    void __stdargs dprintf(UBYTE *fmt,...);  // Parallel debugging...

    #ifndef bug
    #define bug Printf
    #endif

    #ifndef DEBTIME
    #define DEBTIME 0
    #endif

    #ifdef DEBUG
    #define D(x) (x); if(DEBTIME>0) Delay(DEBTIME);
    #else
    #define D(x) ;
    #endif

#endif

#include "psm_head.h"

typedef ULONG (HANDLER)(struct GadOutline *go,ULONG command,struct GOIMsg *msg);

#define HNDCMD_SHUTDOWN 0   // Request to close window.  'msg' contains pointer
                            // to GadOutline which should be closed.
#define HNDCMD_MOVEWIN  1   // Request to move window to go_Screen from outline
                            // passed in 'msg'.
#define HNDCMD_HIDEWIN  2   // Request to temporarily close window.  [Until
                            // a HNDCMD_MOVEWIN message.]
#define HNDCMD_IDCMPMSG 3   // Process message in 'msg'.
#define HNDCMD_TICK     4   // A timer tick occured.
#define HNDCMD_LOCK     5   // Lock your window.
#define HNDCMD_UNLOCK   6   // Unlock your window.

#define HNDRES_NORMAL 0     // All is fine.
#define HNDRES_CLOSEWIN 1   // Request to have window closed.
#define HNDRES_TERMINATE 2  // Request to terminate entire program.

#include "main.h"
#include "vars.h"
#include "lists.h"
#include "tracking.h"
#include "extras.h"
#include "examine.h"
#include "newscrn.h"
