/* C header file for voice.library.

   This header should be #included in any C program 
   which uses voice.library functions.

   voice.o was generated by the genstubs program supplied 
   with Sozobon's ZC C compiler archive. This should
   be linked with C any code that uses voice.library 
   functions.
 
   The voice_lib.fd file used as source to genstubs was
   prepared from the voice.library documentation.
 
   voice.library is copyright Richard Horne, December 1992.

   Many thanks to Richard for his excellent work on voice.library!
 
   David J Benn, 
   Launceston, Tasmania
   December 1992 
*/

#include <exec/types.h>


#define VoiceName	"voice.library"	/* name of library */
#define FREQ_MAP_SIZE	304L		/* # of bytes in each frequency map */


/* digitisers */

#define PERFECTSOUND3	0L
#define	SOUNDMASTER	1L
#define GENERIC		2L


/* timers */
#define TimerA		1L
#define TimerB		0L


/* recognition resolution */

#define HIGH_RES	0L
#define LOW_RES		1L


/* errors */

#define	NO_MATCH	-1L
#define TOO_LOUD	-2L
#define TOO_SOFT	-3L
#define CONFUSED	-4L


/* external functions (voice.o stubs) */

extern 	ULONG 	Learn();
extern 	LONG 	Recognise();
extern 	void 	AddVoiceTask();
extern 	void 	RemVoiceTask();
extern 	void 	GainUp();
extern 	void 	GainDown();
extern 	ULONG 	RecDataAddress();
extern 	ULONG 	RecMapAddress();
extern 	ULONG 	WordScore();
extern 	void 	PickSampler();
extern 	LONG 	SetVoicePri();
extern 	void 	PickTimer();
